#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9 + 7;
const int nl = 0;
struct pr {
    int n;
    int s;
    int i;
    int type;
};
void solve() {
    int n, s;
    cin >> n >> s;
    vector<vector<int> > a(n + 1);
    for (int i = 1; i <= n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    vector<vector<vector<int> > > dp (n + 1, vector<vector<int> > (s + 1));
    vector<vector<vector<pr> > > p (n + 1, vector<vector<pr> > (s + 1));
    dp[0][0].resize(1, 1);
    p[0][0].resize(1, {-1, -1, -1, -1});
    for (int i = 1; i <= s; i++) {
        dp[0][i].resize(1, 0);
        p[0][i].resize(1, {-1, -1, -1, -1});
    }
    for (int i = 1; i <= n; i++) {
        for (int sum = 0; sum <= s; sum++) {
            dp[i][sum].resize(a[i].size() + 1, 0);
            p[i][sum].resize(a[i].size() + 1, {0, 0, 0, 0});
            for (int j = 0; j < a[i].size(); j++) {
                    if (dp[i][sum][j] == 1) {
                        dp[i][sum][j + 1] = 1;
                        p[i][sum][j + 1] = {i, sum, j, 0};
                        continue;
                    }
                if (sum >= a[i][j]) {
                    if (dp[i - 1][sum - a[i][j]][a[i - 1].size()] == 1) {
                        dp[i][sum][j + 1] = 1;
                        p[i][sum][j + 1] = {i - 1, sum - a[i][j], int(a[i - 1].size()), 1};
                        continue;
                    }
                    if (dp[i][sum - a[i][j]][j] == 1) {
                        dp[i][sum][j + 1] = 1;
                        p[i][sum][j + 1] = {i, sum - a[i][j], j, 1};
                    }
                }
            }
        }
    }
    if (dp[n][s][a[n].size()] == 0) {
        cout << "NO";
        return;
    }
    cout << "YES" << '\n';
    vector<vector<int> > ans(n + 1);
    int h = n, f = s, v = a[n].size();
    while (!(h == 0 && f == 0 && v == 0)) {
        if (p[h][f][v].type == 1) {
            ans[h].push_back(v);
        }
        pr r = p[h][f][v];
        h = r.n;
        f = r.s;
        v = r.i;
    }
    for (int i =1 ; i <= n; i++) {
        cout << ans[i].size() << '\n';
        for (int j = 0; j < ans[i].size(); j++) {
            cout << ans[i][j] << " ";
        }
        cout << '\n';
    }
}

int32_t main() {
    solve();
}
