#include <bits/stdc++.h>
using namespace std;
#define int int64_t

const int INF = 1e9 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 2, 0);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }
    vector<int> prevmn(n + 2, INF);
    vector<int> prevmx(n + 2, 0);
    vector<int> prev(n + 1, 0);
    for (int i = 1; i <= n; i++) {
        prevmn[i] = min(a[i], prevmn[i - 1]);
        prev[i] = a[i] + prev[i - 1];
        prevmx[i] = max(a[i], prevmx[i - 1]);
    }
    vector<int> suffmn(n + 2, INF);
    vector<int> suffmx(n + 2, 0);
    for (int i = n; i >= 1; i--) {
        suffmn[i] = min(suffmn[i + 1], a[i]);
        suffmx[i] = max(suffmx[i + 1], a[i]);
    }
    int len = n - k + 1;
    int ans = 0;
    for (int i = 1; i <= n; i++) {
        if (i >= len) {
            int mn = prevmn[i - len];
            mn = min(mn, suffmn[i + 1]);
            mn = min(mn, prev[i] - prev[i - len]);
            int mx = prevmx[i - len];
            mx = max(mx, suffmx[i + 1]);
            mx = max(mx, prev[i] - prev[i - len]);
            ans = max(ans, mx - mn);
        }
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}